# abstract class Crystal::Macros::ControlExpression

- Crystal::Macros::ControlExpression
- Crystal::Macros::ASTNode

##
Overview

The base class of control expressions.

##
Direct Known Subclasses

- Crystal::Macros::Break
- Crystal::Macros::Next
- Crystal::Macros::Return

##
Defined in:

compiler/crystal/macros.cr

##
Instance Method Summary

- #exp : ASTNode | Nop

  Returns the argument to this control expression, if any.

### Instance methods inherited from class `Crystal::Macros::ASTNode`

!=(other : ASTNode) : BoolLiteral !=, ==(other : ASTNode) : BoolLiteral ==, class_name : StringLiteral class_name, column_number : StringLiteral | NilLiteral column_number, doc : StringLiteral doc, doc_comment : MacroId doc_comment, end_column_number : StringLiteral | NilLiteral end_column_number, end_line_number : StringLiteral | NilLiteral end_line_number, filename : StringLiteral | NilLiteral filename, id : MacroId id, is_a?(type : TypeNode) : BoolLiteral is_a?, line_number : StringLiteral | NilLiteral line_number, nil? : BoolLiteral nil?, raise(message) : NoReturn raise, stringify : StringLiteral stringify, symbolize : SymbolLiteral symbolize, warning(message : StringLiteral) : NilLiteral warning

##
Instance Method Detail

def exp : ASTNode | Nop #

Returns the argument to this control expression, if any.

If multiple arguments are present, they are wrapped inside a single `TupleLiteral`.